import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class LibreOfficeDrawSVGtoAiSVG extends PApplet {

//LibreOfficeDrawSVGtoAiSVG
//
// LibreOffice Draw\u3092\u4f7f\u3063\u3066\u30ec\u30fc\u30b6\u30fc\u52a0\u5de5\u6a5f\u306e\u5207\u65ad\u30d1\u30b9\u3092\u4f5c\u6210\u3059\u308b\u6642\u306b
//LibreOffice Draw\u3067\u4fdd\u5b58\u3057\u305fSVG\u30d5\u30a1\u30a4\u30eb\u3092AdobeIllustrator\u306eSVG\u30d5\u30a1\u30a4\u30eb\u98a8\u306b\u5909\u63db\u3059\u308b\u30a2\u30d7\u30ea\u30b1\u30fc\u30b7\u30e7\u30f3
//
//\u8a08\u6e2c\u30fb\u89e3\u6790\u30e9\u30dc\u3000\u5927\u6a4b\u5eb7\u53f8\u30002021.07.22
//\u7121\u4fdd\u8a3c
//CC BY-NC


String svgFile;
String newFileName;
String fileExtension=".svg";
String insertSuffix="_ai.svg";

BufferedReader reader;
String line;
PrintWriter writer;

String headerKey="xml:space="+ PApplet.parseChar(34)+"preserve"+PApplet.parseChar(34)+">";//  xml:space="preserve">
String pathKey="<path fill="+ PApplet.parseChar(34)+"none"+ PApplet.parseChar(34);//                    <path fill="none"
 
public void setup() {
  
  titleText();
  selectInput("\u5909\u63db\u3059\u308bSVG\u30d5\u30a1\u30a4\u30eb\u3092\u9078\u629e\u3057\u3066\u304f\u3060\u3055\u3044\u3002", "newThread");
}

public void convertSVG(){
  reader = createReader(svgFile);//      file path to "User selected SVG file"
  newFileName=svgFile.replace(fileExtension,insertSuffix);
  writer = createWriter(newFileName);
  while(true){
    try {
      line = reader.readLine();
    } catch (IOException e) {
      e.printStackTrace();
      line = null;
    }
    if (line != null) {
      if (line.contains(headerKey)){
        writer.println(line);
      }
      if (line.contains(pathKey)){
        writer.println(line);
      }
      
    } else {
      writer.println("</svg>");
      writer.flush();
      writer.close();
      exit();
    }
  }
}


public void newThread(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    svgFile=selection.getAbsolutePath();
    if(svgFile.contains(fileExtension)){
      println(svgFile);
      println("SVG file Selected");
      convertSVG();
    } else{
      println("Select SVG file");
      exit();
    }
  }
}

  public void titleText(){
    background(190,220,240);
    textSize(40);
    fill(0,0,255);
    text("Convert LibreOffice SVG", 50, 50);
    text("to AI style SVG", 230, 100);
    fill(255,0,0);
    text("Select SVG File", 50, 150);
    delay(3000);
  }
  public void settings() {  size(560,180); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "LibreOfficeDrawSVGtoAiSVG" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
